precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float animationAlpha;
uniform int animate;

uniform int textureReady;

void main()
{
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    vec4 color2 = texture2D(inputImageTexture2, vec2(textureCoordinate2.x, 1.0 - textureCoordinate2.y));

    if (textureReady > 0 && animationAlpha < 1.0){

        gl_FragColor = mix(color, color2, 1.0 -animationAlpha);
        return;
    }

    color *= animationAlpha;

    gl_FragColor = color;
}