precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float intensity;
uniform int hasLookup;
void main() {
    vec4 color = texture2D(inputImageTexture, textureCoordinate.xy); vec2 texelsize = vec2(1.0 / 16.0);
    texelsize.x /= 16.0;
    vec3 lutcoord = vec3((color.xy * 16.0 - color.xy + 0.5) * texelsize.xy, color.z * 16.0 - color.z);
    float lerpfact = fract(lutcoord.z);
    lutcoord.x += (lutcoord.z-lerpfact)*texelsize.y;
    vec3 lutcolor = mix(texture2D(inputImageTexture2, lutcoord.xy).xyz, texture2D(inputImageTexture2, vec2(lutcoord.x + texelsize.y, lutcoord.y)).xyz, lerpfact);
    color.xyz = mix(normalize(color.xyz), normalize(lutcolor.xyz), intensity) *
    mix(length(color.xyz), length(lutcolor.xyz), intensity);
    if (hasLookup == 1){ gl_FragColor = vec4(color.xyz, 1.0); }
    else { gl_FragColor = texture2D(inputImageTexture, textureCoordinate.xy); }
}