precision highp float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform float intensity;

void main() {
    vec4 color = texture2D(inputImageTexture, textureCoordinate.xy);

    vec2 texelsize = vec2(1.0 / 16.0);
    texelsize.x /= 16.0;

    vec3 lutcoord = vec3((color.xy * 16.0 - color.xy + 0.5) * texelsize.xy, color.z * 16.0 - color.z);
    float lerpfact = fract(lutcoord.z);
    lutcoord.x += (lutcoord.z-lerpfact)*texelsize.y;
    vec3 lutcolor = mix(texture2D(inputImageTexture2, lutcoord.xy).xyz, texture2D(inputImageTexture2, vec2(lutcoord.x + texelsize.y, lutcoord.y)).xyz, lerpfact);

    color.xyz = mix(normalize(color.xyz), normalize(lutcolor.xyz), intensity) * mix(length(color.xyz), length(lutcolor.xyz), intensity);

    highp vec4 filtercol = vec4(color.xyz, 1.0);
    highp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 mask = texture2D(inputImageTexture3, textureCoordinate);

    gl_FragColor = mix(base, filtercol, mask.r);
}

//precision highp float;
//uniform sampler2D inputImageTexture;
//uniform sampler2D inputImageTexture2;
//uniform sampler2D inputImageTexture3;
//
//varying vec2 textureCoordinate;
//uniform float intensity;
//
//void main()
//{
//    float slider_progress = abs(intensity);
//    slider_progress = slider_progress * 0.7;
//
//    vec4 curColor = texture2D(inputImageTexture, textureCoordinate);
//    vec4 textureColor = curColor;
//    float blueColor = curColor.b * (17.0 - 1.0);
//    vec2 standardTableSize = vec2(289.0, 17.0);
//    vec2 pixelSize = 1.0 / standardTableSize;
//
//    vec2 quad1 = vec2(0.0);
//    quad1.y = floor(floor(blueColor) / 17.0);
//    quad1.x = floor(blueColor) - (quad1.y * 1.0);
//
//    vec2 quad2;
//    quad2.y = floor(ceil(blueColor) / 17.0);
//    quad2.x = ceil(blueColor) - (quad2.y * 1.0);
//
//    vec2 texPos1;
//    texPos1.x = (quad1.x * 1.0 / 17.0) + 0.5 / standardTableSize.x + ((1.0 / 17.0 - 1.0 / standardTableSize.x) * textureColor.r);
//    texPos1.y = (quad1.y * 1.0 / 1.0) + 0.5 / standardTableSize.y +((1.0 / 1.0 - 1.0 / standardTableSize.y) * textureColor.g);
//
//    vec2 texPos2;
//    texPos2.x = (quad2.x * 1.0 / 17.0) + 0.5 / standardTableSize.x + ((1.0 / 17.0 - 1.0 / standardTableSize.x) * textureColor.r);
//    texPos2.y = (quad2.y * 1.0 / 1.0) + 0.5 / standardTableSize.y +((1.0 / 1.0 - 1.0 / standardTableSize.y) * textureColor.g);
//
//    float alpha = fract(blueColor);
//    vec4 newColor = vec4(0.0);
//
//    vec4 newColor1 = texture2D(inputImageTexture2, texPos1);
//    vec4 newColor2 = texture2D(inputImageTexture2, texPos2);
//    newColor = mix(newColor1, newColor2, alpha);
//
//    newColor = mix(curColor, newColor, slider_progress);
//    highp vec4 mask = texture2D(inputImageTexture3, textureCoordinate);
//
//    gl_FragColor = mix(curColor, newColor, mask.r);
//}
