precision mediump float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform lowp float size;
uniform highp vec2 resolution;

void main() {
    float Directions = 5.0;
    float Quality = 5.0;
    vec2 Radius = size/resolution;
    float PiBlur = 6.28318530718;
    vec2 uv = gl_FragCoord.xy/resolution;
    vec4 inputvec = texture2D(inputImageTexture, uv);

    for( float d=0.0; d<PiBlur; d+=PiBlur/Directions) {
        for(float i=1.0/Quality; i<=1.0; i+=1.0/Quality) {
            inputvec += texture2D(inputImageTexture, uv+vec2(cos(d), sin(d))*Radius*i);
        }
    }
    inputvec /= Quality * Directions;

    gl_FragColor = inputvec;
}